/*
 * callbacks.c
 * Copyright (C) wkt 2007 <linux@debian>
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
//#define _GNU_SOURCE
#include <stdio.h>
#include <unistd.h>
#include<grp.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <stdlib.h>
#include <string.h>
#include<signal.h>
#include <errno.h>
#include <gtk/gtk.h>
//#include <libnotify/notify.h>

#include "callbacks.h"
#include "main.h"
#include "guis.h"
#include "func.h"
#include "debug.h"

 char *dpath="/etc/ppp/peers";

 const char *logfile="/tmp/.pppd.log.file";

__def def = {"dsl-provider",NULL,NULL,NULL};

 void dis_connect()
 {
     char *cmd[]={"/usr/bin/poff",def.adslname,NULL};
     if(access(cmd[0],X_OK)==0){
       g_print("dis_connect:adslname -> %s\n",def.adslname);
       g_print("EXEC /usr/bin/poff %s\n",def.adslname);
       g_print("dis_connect:my_exec(): return %d \n",my_exec(cmd,0));
       my_exec(cmd,0);//for safe
     }
      else
//     my_exec(cmd,-1);
       if(is_pppoe_on()&&pppd.pid>5){
         g_print("Try to kill pppd pid = %d.\n",pppd.pid);
         if( kill(pppd.pid,15)==-1)
           fprintf(stderr,"dis_connect():kill():%s .\n",strerror(errno));
          //for no poff like magiclinux
     }
 }

void status_page(GtkStatusIcon *status_icon,gpointer data)
{
//  static char pet = 's';
//   if(pet == 'h'){
     if( gtk_window_is_active (GTK_WINDOW(window))){
     gtk_widget_hide(window);
//     pet = 's';
     return ;
     }
//   }
  gtk_window_present(GTK_WINDOW(window));
  //gtk_widget_show_all(note);
  gtk_notebook_set_current_page(GTK_NOTEBOOK(note),2);
//  pet = 'h';
  //g_print("status_page()\n");
}

void  status_notify(GObject *gobject, GParamSpec *arg1, gpointer user_data)
{
//    g_print("It works !\n");
}

void status_pop_menu(GtkStatusIcon* icon, guint button, guint activate_time,gpointer user_data)
{
//     gint x, y;
//    gboolean push_in;
    GtkWidget* prop ;
    GtkWidget* dis_connect ;
    GtkWidget* menu = gtk_menu_new();

    gpointer flag=NULL ;/// I don't want flag to be this type .
                        ///But when try something else there are some problem .

    if(is_pppoe_on()){
     dis_connect = gtk_menu_item_new_with_mnemonic(_("_Disconnect"));
     flag = (void*)0xffffffff;
    }
    else{
     dis_connect = gtk_menu_item_new_with_mnemonic(_("_Connect"));
     flag = NULL;
    }
    //g_print("flag :%p\n",flag);
    g_signal_connect((gpointer)dis_connect, "activate", G_CALLBACK(on_disconnect), flag);

    gtk_menu_shell_append(GTK_MENU_SHELL(menu), dis_connect);

    if(gtk_window_is_active(GTK_WINDOW(window))){
      prop= gtk_menu_item_new_with_mnemonic(_("_Hide"));
      flag = (void*)0xffffffff;
    }
     else {
       prop = gtk_menu_item_new_with_mnemonic(_("_Show"));
       flag = NULL;
    }

    g_signal_connect((gpointer)prop, "activate", GTK_SIGNAL_FUNC(on_prop), flag);
    gtk_menu_shell_append(GTK_MENU_SHELL(menu), prop);

    GtkWidget* sep = gtk_separator_menu_item_new();
    gtk_menu_shell_append(GTK_MENU_SHELL(menu), sep);

    GtkWidget* quit = gtk_menu_item_new_with_mnemonic(_("_Quit"));
    g_signal_connect((gpointer)quit, "activate", G_CALLBACK(on_quit), NULL);
    gtk_menu_shell_append(GTK_MENU_SHELL(menu), quit);

    gtk_widget_show(dis_connect);
    gtk_widget_show(prop);
    gtk_widget_show(sep);
    gtk_widget_show(quit);
    gtk_widget_show(menu);

    /* gtk_status_icon_position_menu(GTK_MENU(menu), &x, &y, &push_in, icon); */
    gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, 1, gtk_get_current_event_time());
    //g_print("Goddman it.\n");
}

gboolean on_window_delete_event(GtkWidget *widget,GdkEvent *event,   gpointer user_data)
{
  if(is_pppoe_on())gtk_widget_hide(widget);
    else{
      dis_connect();
      gtk_main_quit();
    }
  return TRUE;
}

gboolean on_status_delete_event(GtkWidget *widget,GdkEvent *event,   gpointer user_data)
{
   gtk_widget_hide(widget);
   //g_print("status:goddman it.\n");
   dis_connect(); ///stop pppd before quit .
   gtk_main_quit();
   return TRUE;
}

void on_quit (GtkMenuItem *menuitem, gpointer  user_data)
{
  //if(pppd.pid>5)kill(pppd.pid,15);
  dis_connect();
  gtk_main_quit();
}



void on_prop(GtkMenuItem *menuitem, gpointer user_data)
{
 //g_print("User_data : %p\n",user_data);
 if(user_data){
  //g_print("Hide window.\n");
  gtk_widget_hide(window);
 }
  else {
  	//g_print("Show window.\n");
  	gtk_window_present(GTK_WINDOW(window));
  }
}

gboolean on_disconnect (GtkWidget *widget,gpointer user_data)
{
  //if(pppd.pid>5)kill(pppd.pid,15);
  //g_print("user_data:%p \n",user_data);

  if(user_data){

    dis_connect();
	  gtk_widget_hide(statuswin);
//	gtk_widget_show(window);
	  gtk_status_icon_set_from_stock(GTK_STATUS_ICON(status_icon),GTK_STOCK_REFRESH);
//	fprintf(stderr,"%d\n",pppd.pid);
	}
	else   on_connect(NULL,NULL);

	return FALSE;
}

gboolean on_wvdial_out (GIOChannel *source, GIOCondition condition, gpointer data)
{
//	gtk_widget_show(statuswin);
	GtkWidget * label = statuslabel;//lookup_widget(statuswin,"statuslabel");
  gchar *line ,*line1;
  GIOStatus status;

  status = g_io_channel_read_line (source, &line1, NULL, NULL, NULL);

  line = get_addr(line1,'p');
  if (status != G_IO_STATUS_NORMAL)
    return FALSE;
#ifndef magic_linux
  if(g_strrstr(line,"pppd"))g_print ("ADSL Dialer: STDOUT: %s", line);
    else { g_free(line1); return TRUE ;}
#else
  g_print ("ADSL Dialer: STDOUT: %s", line);
#endif

	if (g_strrstr (line, "Using interface") != NULL)
		{
		 gtk_label_set_text (GTK_LABEL (label), _("Connecting..."));
		 g_print ("USEFUL: %s", line);
		}
	if (g_strrstr (line, "Connection terminated.") != NULL)
		{

			gtk_status_icon_set_from_stock(GTK_STATUS_ICON(status_icon),GTK_STOCK_REFRESH);
			gtk_label_set_text (GTK_LABEL (label), _("Connection failed..."));
	 		///if( !gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(chb1)))  gtk_widget_show_all(dialog1);

	 		static gint id = 0;
	 		if(id)goto loop;
	 		id = msgbox(_("Connection failed..."),0,TRUE);
                             
	 		switch(id){
	 		 case 1:
                           gtk_widget_hide(statuswin);
                           gtk_widget_show(window);
	 		   break;
	 		 case 2:
                           gtk_widget_hide(statuswin);
                           gtk_widget_show(window);
	 		   break;
	 		 default:
                           gtk_widget_hide(statuswin);
                           gtk_widget_show(window);
	 		   break;
	 		 }
    id =0;
		}
	//	 g_print("FAILED");
	if (g_strrstr (line, "authentication succeeded") != NULL)
			 gtk_label_set_text (GTK_LABEL (label), _("Authentication succeeded"));
	if (g_strrstr (line, "replacing old default route") != NULL)
			 gtk_label_set_text (GTK_LABEL (label), _("Setting local route"));
	if (g_strrstr (line, "remote IP address") != NULL){
		 //gtk_widget_show(window);
                 gint id = 0;
		 gtk_label_set_text (GTK_LABEL (label), _("Ready to use"));

	         gtk_status_icon_set_from_stock(GTK_STATUS_ICON(status_icon),GTK_STOCK_NETWORK);
                // id = msgbox(_("Succeeded."),5,FALSE);
                  switch(id){
                    case 1 :
                       dis_connect();
                       gtk_main_quit();
                       break;
                    default:
                      break;
                   }
                 gtk_widget_hide(statuswin);
	  }
loop:  g_free (line1);
  return TRUE;
}

gboolean save_pro_changed(gchar *asl)
{
 gchar *pwd= (gchar*) gtk_entry_get_text(GTK_ENTRY(password_edit));
 gchar *unm= (gchar*) gtk_entry_get_text(GTK_ENTRY(username_edit));
// gchar *asl= gtk_combo_box_get_active_text(GTK_COMBO_BOX(adslname_edit));
 //g_print("passwd:  %-25s--%25s\n",pwd,def.passwd);
 g_print("username:%-25s--%25s\n",unm,def.username);
 g_print("adslname:%-25s--%25s\n",asl,def.adslname);

 if(strcmp(unm,def.username)||strcmp(pwd,def.passwd)||strcmp(asl,def.adslname))
 {

   g_print("save_pro_changed().\n");
   save_profile(pwd,unm,asl);
   del_user_in("/etc/ppp/chap-secrets",def.username);
   del_user_in("/etc/ppp/pap-secrets",def.username);
   write_password_file(unm,pwd,"/etc/ppp/chap-secrets");
   write_password_file(unm,pwd,"/etc/ppp/pap-secrets");
   load_active_pro(adslname_edit);
   def.passwd=pwd; //update defaults
   def.username=unm;
   def.adslname=asl;
   return TRUE;
  }
  //g_print("Quit out  save_pro_changed()\n");
  return FALSE;
}

gint my_io_watch(gchar *file,GIOFunc func,GIOCondition condition)
{
 int in = 0;
 int out = 1;
 int err = 3;

 GIOCondition gcdn = G_IO_IN | G_IO_HUP | G_IO_ERR;
 static GIOChannel *gout = NULL;
 gchar *cmd[] = {"/usr/bin/tail","-s1","-n0","-f",file,NULL};
 GError *error = NULL;

 if(gout){
  g_print("my_io_watch(): I run before .\n");
  return -1;
 }
//  GIOChannel *gerr;
 g_print("my_io_watch():I try to watch %s.\n",file);

 if(access(file,F_OK)){
   g_print("my_io_watch:access() %s:%s",file,strerror(errno));
/*   char *cli[]={"touch",file,NULL};
   g_print("Try touch %s .\n",file);
   my_exec(cli,0);
*/
  fclose(fopen(file,"a+"));
  }
  tail_pid = 0;
 if(!g_spawn_async_with_pipes(NULL,
 				cmd,
 				NULL,
 				G_SPAWN_SEARCH_PATH,
 				NULL,NULL,
 				&tail_pid,&in,&out,
 				&err,&error
                               )){
 	   g_print("my_io_watch():Failed to %s .\n",file);
 	   g_error_free (error);
 	   error = NULL;
 	 }
 	else {
 	  gout = g_io_channel_unix_new (out);
 	  g_io_channel_set_encoding (gout, NULL, NULL);
          if(condition)gcdn = condition ;//g_io_channel_seek_position(gout,-1l,G_SEEK_END,&error);
          g_io_add_watch (gout,gcdn,func,NULL);
          g_io_channel_unref (gout);
 }
 return 0;
}

void on_connect (GtkWidget  *widget,  gpointer user_data)
{

	gchar * profilename = gtk_combo_box_get_active_text(GTK_COMBO_BOX(adslname_edit));
	//fprintf(stderr,"%s\n",profilename);
  int id = 0;
  if(is_pppoe_on())id = msgbox(_("\nPPP is online already .OK to continue ,cancel ot cancel.\n"),0,TRUE);
  switch(id){
    case 0:
    case 2:
    break;
   case 1:
    return;
   default:
    return ;
  } 
  if(save_pro_changed(profilename))g_print("Profile saved.\n");

	pppd.cmd[0] = "/usr/sbin/pppd";
	pppd.cmd[1] = "call";
	pppd.cmd[2] = profilename;
	pppd.cmd[3] = NULL;

  dis_connect();///before connect we shut down .
	g_print("EXEC /usr/sbin/pppd call %s\n",profilename);

  if (!g_spawn_async_with_pipes (NULL,
                                 (char **)pppd.cmd,
                                 NULL,
                                 G_SPAWN_SEARCH_PATH,
                                 NULL, NULL,
                                 &pppd.pid,
                                 &pppd.in_pipe,
                                 &pppd.out_pipe,
                                 &pppd.err_pipe,
                                 &pppd.error)) {
                g_warning (_("ADSL Dialer: Command failed: %s\n"), pppd.error->message);
                g_error_free (pppd.error);
                pppd.error = NULL;
        }
        else {
        	gtk_widget_hide(window);

	        gtk_widget_show(statuswin);

          debug(g_print("pppd pid :%d .\n",pppd.pid));
	         //GtkWidget * label = lookup_widget(statuswin,"statuslabel");
          gtk_label_set_text (GTK_LABEL ( statuslabel), _("Prepare to connecting..."));

         if( access("/var/log/syslog",F_OK) == 0 )
               my_io_watch("/var/log/syslog",on_wvdial_out,0);
          else
              my_io_watch((char *)logfile,on_wvdial_out,0);
         }
    //if(tmp)free(tmp);
	//g_print("Sorry,we do nothing right now!\n");
}

void on_del (GtkWidget  *widget,  gpointer user_data)
{
 char file[1024]={0};

 sprintf(file,"%s/%s",dpath,gtk_combo_box_get_active_text(GTK_COMBO_BOX(adslname_edit)));
 if(remove(file))g_print("Can't remove %s\n",file);
 gint i = gtk_combo_box_get_active(GTK_COMBO_BOX(adslname_edit));
 //gint j = gtk_combo_box_get_column_span_column(GTK_COMBO_BOX(adslname_edit));
 //if(i==0)j=i;
 //g_print("i= %d j=%d\n",i,j);
 gtk_combo_box_set_active(GTK_COMBO_BOX(adslname_edit),i+1);
 gtk_combo_box_remove_text(GTK_COMBO_BOX(adslname_edit),i);
  //j= gtk_combo_box_get_row_span_column(GTK_COMBO_BOX(adslname_edit));
  //g_print("i= %d j=%d\n",gtk_combo_box_get_active(GTK_COMBO_BOX(adslname_edit)),j);


}

gboolean enter_press(GtkWidget *widget,GdkEventKey *event,GtkWidget *data)
{
  gchar ch=event->keyval;
  //g_print("key code %3d pressed .\n",ch);

  if(ch==13||ch==10){
    if(gtk_notebook_get_current_page(GTK_NOTEBOOK(data)))return FALSE;
    if(is_pppoe_on())return 	FALSE ;

    on_connect(NULL,NULL);
   return TRUE;
 }
 if(ch==-1||ch==27||ch==-97)gtk_main_quit();
 if(ch=='&'||ch=='*'||ch==';'||ch=='>'||ch=='<'||ch=='|'||ch=='?')return TRUE;
 return FALSE ;
}


void combox_entry_changed(GtkEntry *entry,gpointer data)
{
/*
 gchar *text,*p;
 text = (gchar *) gtk_entry_get_text (entry);
 p = text;
 while(*p){
  char ch= *p;
  if(ch=='&'||ch=='*'||ch==';'||ch=='>'||ch=='<'||ch=='|'||ch=='?'){ *p=0; break ; }
  p++;
 }
 g_print("god:%s\n",text);
 gtk_entry_set_text(entry,text);
*/
}

void on_windowcancel_btn_clicked(GtkWidget  *widget, gpointer user_data)
{
  if(is_pppoe_on())dis_connect();
  g_print("quit for cancled !\n");
  gtk_main_quit();

}



void load_interfaces()
{
  char *line=NULL;
  gchar **inter;
  char *fpath="/proc/net/dev";
  size_t len=0;
  FILE *file;  ///at the begin ,I want a argument .now I use a global variable instead
#define  shows  interface_combo
  if((file=fopen(fpath,"r"))==NULL){
    g_print("Can't fopen %s .\nWill not work.\n",fpath);
 }
  while(getline(&line,&len,file)!=-1){
   char * l = g_strstrip(line);
   if (g_strrstr (l, "eth"))
   	{
     inter= g_strsplit(l,":",0);
     if(shows)gtk_combo_box_append_text(GTK_COMBO_BOX(shows),*inter);
     //g_print("%s\n",*inter);
	  }
  }
  fclose(file);
  if(shows){
   gtk_combo_box_set_active (GTK_COMBO_BOX(shows),0);
   g_print("%s is actived.\n",gtk_combo_box_get_active_text(GTK_COMBO_BOX(shows)));
	}
#undef shows
}

//void update_

void load_profile(GtkWidget *shows)
{
	DIR *dir=NULL;
	struct dirent *dirs=NULL;
  int i=0;
  debug(if(!shows)g_print("adslname_edit is NULL!"));
	if(!(dir=opendir(dpath)))
	{
	 g_print("Can't opendir %s : %s .\n",dpath,strerror(errno));
	 exit(1);
	}
	while((dirs=readdir(dir))){
	 if(dirs->d_type==8){
		/*
		g_print("\ndirs->d_ino:%ld\ndirs->d_off:%ld\n"
						"dirs->d_reclen:%d\ndirs->d_type:%d\ndirs->d_name:%s\n\n"
						,dirs->d_ino,dirs->d_off,dirs->d_reclen,dirs->d_type,dirs->d_name);
		*/
     if(shows){
      gtk_combo_box_append_text(GTK_COMBO_BOX(shows),dirs->d_name);
      i++;
     }
    //g_print("before strcmp\n");
    //g_print("after strcmp\n");
	 }
	}
  gtk_combo_box_set_active (GTK_COMBO_BOX(shows),i>0?i-1:0);
	closedir(dir);
	debug(g_print("load_profile():exit .\n"));


}

void combox_changed(GtkComboBox *widget, gpointer user_data)
{
  load_active_pro(GTK_WIDGET(widget));
}


void ckb_handler(GtkToggleButton *togglebutton,Iwgt * data)
{
 gchar *cmd[]={shell_path"/scripts/defroute","gw",NULL,NULL};
 if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(togglebutton)))
  {
   switch(data->i){
    case 0 :
     my_exec_str(shell_path"/scripts/share on",1);
     break;
    case 1 :
     gtk_entry_set_editable (GTK_ENTRY(data->gwt),TRUE);
     cmd[2] = (gchar*)gtk_entry_get_text(GTK_ENTRY(data->gwt));
     if(cmd[2][0]){
          if(!my_exec(cmd,0))g_print("Set gateway failure !\n");
     }else
        my_exec_str(shell_path"/scripts/defroute gw ppp",1);
     break;
    default:
     break;
   }
   g_print("button %d: %s selected .\n",data->i,gtk_button_get_label(	GTK_BUTTON(togglebutton)));
  }
 else{
   switch(data->i){
    case 0 :
     my_exec_str(shell_path"/scripts/share off",1);
     break;
    case 1:
     gtk_entry_set_editable (GTK_ENTRY(data->gwt),FALSE);
     break;
    default:
     break ;
   }
    g_print("button %d :%s canceled .\n",data->i,gtk_button_get_label(	GTK_BUTTON(togglebutton)));
 }
}

void entry_handler(GtkWidget *entry,GtkWidget *data)
{
  gchar *cmd[]={shell_path"/scripts/defroute","gw",NULL,NULL};
  int id = 0;
  cmd[2] = (gchar*)gtk_entry_get_text(GTK_ENTRY(entry));

  if(cmd[2][0])
         id = my_exec(cmd,0);
  else g_print("Nothing be done .\n");
  if(!id)g_print("Set gateway failure !\n");
}

void do_ok(GtkWidget *widget,GtkWidget *data)
{
  gtk_widget_hide(data);
}

void do_rect(GtkWidget *widget,GtkWidget *data)
{
 gtk_widget_hide(data);
 on_connect(NULL,NULL);

}

void load_active_pro(GtkWidget *widget)
{
 char *file=NULL;
 char *rfile=NULL;
 FILE *f=NULL;
 //def.username=gtk_entry_get_text(GTK_ENTRY(username_edit));
 //def.passwd=gtk_entry_get_text(GTK_ENTRY(password_edit));
 if(widget)file = gtk_combo_box_get_active_text(GTK_COMBO_BOX(widget));

 rfile = malloc(strlen(file)+strlen(dpath)+4);
 if(!rfile){
    g_print("load_active_pro:Malloc():%s !\n",strerror(errno));
    exit(255);
  }
 sprintf(rfile,"%s/%s",dpath,file);
 g_print("load_active_pro()->Default file :%s .\n",rfile);
 f=fopen(rfile,"r");
 if(!f){
   g_print("Can't fopen %s :%s\n",rfile,strerror(errno));
//   return;
  }
 else
  def.adslname = file;

 def.username = get_username_from(rfile);

 if(def.username) def.passwd = get_passwd_of(def.username);

 if(def.username){
   gtk_entry_set_text(GTK_ENTRY(username_edit),def.username);
   //gtk_entry_set_invisible_char(GTK_ENTRY(password_edit),'f');

 }
 else{
    def.username="";
    def.passwd="";
    gtk_entry_set_text(GTK_ENTRY(username_edit),"");
 }
   if(!def.passwd)def.passwd="";
   gtk_entry_set_text(GTK_ENTRY(password_edit),def.passwd);
   //g_print("username:%s,passwd:%s\n",def.username,def.passwd);

 if(rfile)free(rfile);
 if(f)fclose(f);
 g_print("I'm OK in load_pro_active .\n");
}

char * get_username_from(char *profile)
{
   FILE * filer = fopen(profile,"r");
   ssize_t read;
   char * line = NULL;
   size_t len = 0;
   static char user[64]={0};//my username have more than it .
   if(!filer){
     fprintf(stderr,"get_username_from:fopen:%s .\n",strerror(errno));
     return NULL;
   }
   while((read = getline(&line,&len,filer))!=-1)
     {

      if (g_strrstr (line, "user"))
      {
      gchar ** str_array;
      g_print(line);
      str_array = g_strsplit(line,"\"",0);
      debug(g_print(str_array[1]));
      strcpy(user,str_array[1]?str_array[1]:"ERROR!");
      fclose(filer);
      g_strfreev(str_array);
      debug(g_print("user:%s\n",user));
      free(line);
	    return user;
     }

   }
   if(line)free(line);
   if(filer)fclose(filer);
   //g_print("I did it 2.\n");
   return NULL;
}

char *get_passwd_of(char *username)
{
  ssize_t read;
//  be_root();
	size_t len =0;
	char * line = NULL;
	static char passwd[32] = {0};

	if(!username){
	  g_print("username is NULL !\n");
	  return NULL;
	}
	FILE * filer = fopen("/etc/ppp/pap-secrets","r");

  if(!filer){
   fprintf(stderr,"get_passwd_of:%s .\n",strerror(errno));
   return NULL;
  }

  while(filer&&(read = getline(&line,&len,filer))!=-1)
   {
    if(read >1)
     {
      //gchar * l = line;
      //fprintf(stderr,"%s\n",l);
      gchar ** str_array;
      str_array = g_strsplit(line,"\"",0);
      gchar * user_str = str_array[1];
      //fprintf(stderr,"username: %s:%s\n",username,user_str);
      if(user_str&&!strcmp(username,user_str))
       {
		     //fprintf(stderr,"password:%s\n\n",str_array[3]);
         strcpy(passwd,str_array[3]);
         //fclose(filer);
		     //str_array[3];
      }
     g_strfreev(str_array);
	  }

  }
 if(line)free(line);
 if(filer)fclose(filer);
 return passwd;
 //return NULL;
}

void save_profile(char *pw,char *unm,char *adsl)
{

  FILE *f1=NULL;
  char *str=NULL;
  str = malloc(strlen(adsl)+strlen(dpath)+64);
  if(!str){
     g_print("save_profile:malloc :%s .\n",strerror(errno));
     return ;
  }
   sprintf(str,"%s/%s",dpath,adsl);
  if(access(str,F_OK) ==0){
    sprintf(str,"/bin/sed -i 's=\".*\"$=\"%s\"=g' %s/%s",unm,dpath,adsl);
    g_print("%s\n",str);
    my_exec_str(str,0);
  }
  else{
    f1=fopen(str,"w+");
    if(!f1)g_print("Can't fopen %s .\n",str);
     else{
        fprintf(f1,"noipdefault\n");
        fprintf(f1,"defaultroute\n");
#ifndef magic_linux
        fprintf(f1,"replacedefaultroute\n"); ///pppd in magiclinux don't accept this option
#endif
        fprintf(f1,"hide-password\n");
        fprintf(f1,"noauth\n");
        fprintf(f1,"persist\n");
        fprintf(f1,"plugin rp-pppoe.so %s\n",
                    gtk_combo_box_get_active_text(GTK_COMBO_BOX(interface_combo)));
        fprintf(f1,"usepeerdns\n");
        fprintf(f1,"user \"%s\"\n",unm);
        fprintf(f1,"logfile %s\n",logfile);
        gtk_combo_box_append_text(GTK_COMBO_BOX(adslname_edit),adsl);
    }
   	if(f1)fclose(f1);
    if(chown(str,0,(getgrnam("dip"))->gr_gid)==-1)///do what pppoeconf do in debian linux .
              g_print("line : %d :save_profile():chown(): %s .\n",__LINE__,strerror(errno));
  }
  //system(str);
  //fprintf(f1,"
  //g_print("save_profile runed.\n");
}


void write_password_file(char * username, char * password,char *file)
{
  gboolean found = FALSE;
  char *line=NULL;
	size_t len=0;
	ssize_t read;
//        GList * list = NULL;
  umask(0077);
  char *tmpfile = "/tmp/.pppd.secrets";
	FILE * filer = fopen(file,"r");
	FILE * filew = fopen(tmpfile,"w");

   while((read = getline(&line,&len,filer))!=-1)
	  {
	    if(read >1){
	       gchar * l = line;
//	fprintf(stderr,"%s\n",l);
	       gchar ** str_array;
	       str_array = g_strsplit(l,"\"",0);
	       gchar * user_str = str_array[1];
	//fprintf(stderr,"username: %s\n",user_str);
	       if(user_str&&!strcmp(username,user_str)){

		        found = TRUE;
		        char * tmpline;
            tmpline = malloc(100);
            if(!tmpline){
              g_print("write_password_file:%d:malloc():%s .\n",__LINE__,strerror(errno));
              free(line);
              return ;/// go without work be done.
             }
            bzero(tmpline,100);
            sprintf(tmpline,"\"%s\" * \"%s\"\n",username,password);
		        fprintf(filew,"%s",tmpline);
		        free(tmpline);
	       }
        else
		      fprintf(filew,"%s",line);
 	   }

	}
	 if(line)free(line);
   if(!found){
     char * tmpline;
     tmpline = malloc(100);
     if(!tmpline){
       g_print("write_password_file:%d:malloc():%s .\n",__LINE__,strerror(errno));
       return ;
     }
     bzero(tmpline,100);
     sprintf(tmpline,"\"%s\" * \"%s\"\n",username,password);
		 fprintf(filew,"%s",tmpline);
		 free(tmpline);
   }

	fclose(filer);
	fclose(filew);

	unlink(file);
	rename(tmpfile,file);

}




